Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 74765)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 74766)
@@ -80,5 +80,5 @@
     AssertReturnVoid(m_pFormatComboBox->count() == 0);
 
-    /* Apply hardcoded format list: */
+    /* Compose hardcoded format list: */
     QStringList formats;
     formats << "ovf-0.9";
@@ -87,9 +87,11 @@
     formats << "opc-1.0";
     formats << "csp-1.0";
-    m_pFormatComboBox->addItems(formats);
-
-    /* Duplicate non-translated names to data fields: */
-    for (int i = 0; i < m_pFormatComboBox->count(); ++i)
-        m_pFormatComboBox->setItemData(i, m_pFormatComboBox->itemText(i));
+    /* Add that list to combo: */
+    foreach (const QString &strShortName, formats)
+    {
+        /* Compose empty item, fill it's data: */
+        m_pFormatComboBox->addItem(QString());
+        m_pFormatComboBox->setItemData(m_pFormatComboBox->count() - 1, strShortName, FormatData_ShortName);
+    }
 
     /* Set default: */
@@ -117,22 +119,19 @@
     AssertReturnVoid(m_pAccountComboBox->count() == 0);
 
-    /* Acquire provider list: */
-    QVector<CCloudProvider> comProviders = m_comCloudProviderManager.GetProviders();
-
     /* Iterate through providers: */
-    foreach (const CCloudProvider &comProvider, comProviders)
+    foreach (const CCloudProvider &comCloudProvider, m_comCloudProviderManager.GetProviders())
     {
         /* Skip if we have nothing to populate (file missing?): */
-        if (comProvider.isNull())
+        if (comCloudProvider.isNull())
             continue;
 
         /* Iterate through profile names: */
-        foreach (const QString &strProfileName, comProvider.GetProfileNames())
+        foreach (const QString &strProfileName, comCloudProvider.GetProfileNames())
         {
             m_pAccountComboBox->addItem(QString());
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comProvider.GetId(), ProviderID);
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comProvider.GetName(), ProviderName);
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comProvider.GetShortName(), ProviderShortName);
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, strProfileName, ProfileName);
+            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comCloudProvider.GetId(),        AccountData_ProviderID);
+            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comCloudProvider.GetName(),      AccountData_ProviderName);
+            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, comCloudProvider.GetShortName(), AccountData_ProviderShortName);
+            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, strProfileName,                  AccountData_ProfileName);
         }
     }
@@ -145,4 +144,7 @@
 void UIWizardExportAppPage2::populateAccountProperties()
 {
+    /* Clear table initially: */
+    m_pAccountPropertyTable->clear();
+
     /* Acquire Cloud Provider: */
     CCloudProvider comCloudProvider = m_comCloudProviderManager.GetProviderById(providerId());
@@ -156,7 +158,4 @@
     if (m_comCloudProfile.isNull())
         return;
-
-    /* Clear table initially: */
-    m_pAccountPropertyTable->clear();
 
     /* Acquire properties: */
@@ -365,12 +364,13 @@
 void UIWizardExportAppPage2::setFormat(const QString &strFormat)
 {
-    const int iIndex = m_pFormatComboBox->findData(strFormat);
+    const int iIndex = m_pFormatComboBox->findData(strFormat, FormatData_ShortName);
     AssertMsg(iIndex != -1, ("Data not found!"));
     m_pFormatComboBox->setCurrentIndex(iIndex);
 }
+
 QString UIWizardExportAppPage2::format() const
 {
     const int iIndex = m_pFormatComboBox->currentIndex();
-    return m_pFormatComboBox->itemData(iIndex).toString();
+    return m_pFormatComboBox->itemData(iIndex, FormatData_ShortName).toString();
 }
 
@@ -420,5 +420,5 @@
 void UIWizardExportAppPage2::setProviderById(const QString &strId)
 {
-    const int iIndex = m_pAccountComboBox->findData(strId, ProviderID);
+    const int iIndex = m_pAccountComboBox->findData(strId, AccountData_ProviderID);
     AssertMsg(iIndex != -1, ("Data not found!"));
     m_pAccountComboBox->setCurrentIndex(iIndex);
@@ -428,5 +428,5 @@
 {
     const int iIndex = m_pAccountComboBox->currentIndex();
-    return m_pAccountComboBox->itemData(iIndex, ProviderID).toString();
+    return m_pAccountComboBox->itemData(iIndex, AccountData_ProviderID).toString();
 }
 
@@ -434,5 +434,5 @@
 {
     const int iIndex = m_pAccountComboBox->currentIndex();
-    return m_pAccountComboBox->itemData(iIndex, ProviderShortName).toString();
+    return m_pAccountComboBox->itemData(iIndex, AccountData_ProviderShortName).toString();
 }
 
@@ -440,5 +440,5 @@
 {
     const int iIndex = m_pAccountComboBox->currentIndex();
-    return m_pAccountComboBox->itemData(iIndex, ProfileName).toString();
+    return m_pAccountComboBox->itemData(iIndex, AccountData_ProfileName).toString();
 }
 
@@ -753,5 +753,5 @@
     m_pFileSelector->setFileDialogTitle(UIWizardExportApp::tr("Please choose a file to export the virtual appliance to"));
 
-    /* Translate Format combo-box: */
+    /* Translate hardcoded values of Format combo-box: */
     m_pFormatComboBoxLabel->setText(UIWizardExportApp::tr("F&ormat:"));
     m_pFormatComboBox->setItemText(0, UIWizardExportApp::tr("Open Virtualization Format 0.9"));
@@ -797,6 +797,6 @@
     {
         m_pAccountComboBox->setItemText(i, UIWizardExportApp::tr("%1: %2", "provider: profile")
-            .arg(m_pAccountComboBox->itemData(i, ProviderName).toString())
-            .arg(m_pAccountComboBox->itemData(i, ProfileName).toString()));
+            .arg(m_pAccountComboBox->itemData(i, AccountData_ProviderName).toString())
+            .arg(m_pAccountComboBox->itemData(i, AccountData_ProfileName).toString()));
     }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.h	(revision 74765)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.h	(revision 74766)
@@ -53,11 +53,17 @@
 Q_DECLARE_METATYPE(MACAddressPolicy);
 
+/** Format combo data fields. */
+enum
+{
+    FormatData_ShortName = Qt::UserRole + 1
+};
+
 /** Account combo data fields. */
 enum
 {
-    ProviderID        = Qt::UserRole + 1,
-    ProviderName      = Qt::UserRole + 2,
-    ProviderShortName = Qt::UserRole + 3,
-    ProfileName       = Qt::UserRole + 4
+    AccountData_ProviderID        = Qt::UserRole + 1,
+    AccountData_ProviderName      = Qt::UserRole + 2,
+    AccountData_ProviderShortName = Qt::UserRole + 3,
+    AccountData_ProfileName       = Qt::UserRole + 4
 };
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 74765)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 74766)
@@ -390,5 +390,5 @@
     m_pFileSelector->setFileDialogTitle(UIWizardExportApp::tr("Please choose a file to export the virtual appliance to"));
 
-    /* Translate Format combo-box: */
+    /* Translate hard-coded values of Format combo-box: */
     m_pFormatComboBoxLabel->setText(UIWizardExportApp::tr("F&ormat:"));
     m_pFormatComboBox->setItemText(0, UIWizardExportApp::tr("Open Virtualization Format 0.9"));
@@ -434,6 +434,6 @@
     {
         m_pAccountComboBox->setItemText(i, UIWizardExportApp::tr("%1: %2", "provider: profile")
-            .arg(m_pAccountComboBox->itemData(i, ProviderName).toString())
-            .arg(m_pAccountComboBox->itemData(i, ProfileName).toString()));
+            .arg(m_pAccountComboBox->itemData(i, AccountData_ProviderName).toString())
+            .arg(m_pAccountComboBox->itemData(i, AccountData_ProfileName).toString()));
     }
 