Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 74769)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 74770)
@@ -48,7 +48,7 @@
  LIBRARIES += ServicesR0
  DLLS      += VBoxDDU VBoxDD VBoxDD2
- SYSMODS   += VBoxDDR0 VBoxDD2R0
+ SYSMODS   += VBoxDDR0
  ifdef VBOX_WITH_RAW_MODE
-  SYSMODS   += VBoxDDRC VBoxDD2RC
+  SYSMODS   += VBoxDDRC
  endif
 
@@ -1199,37 +1199,4 @@
 
 
- ifdef VBOX_WITH_RAW_MODE
-  #
-  # VBoxDD2RC (LGPL sysmod)
-  #
-  VBoxDD2RC_TEMPLATE       = VBoxRc
-  VBoxDD2RC_INCS           = build
-  VBoxDD2RC_SOURCES        = \
- 	build/VBoxDD2R0.cpp # Dummy to prevent linking errors.
-  if1of ($(VBOX_LDR_FMT32), pe lx)
-   VBoxDD2RC_LIBS          = \
-   	$(PATH_STAGE_LIB)/VMMRCBuiltin$(VBOX_SUFF_LIB) \
-   	$(PATH_STAGE_LIB)/VMMRCImp$(VBOX_SUFF_LIB)
-  endif
-  $(call VBOX_SET_VER_INFO_RC,VBoxDD2RC,VirtualBox VMM Devices and Drivers 2$(COMMA) raw-mode)
- endif
-
-
- #
- # VBoxDD2R0 (LGPL sysmod)
- #
- VBoxDD2R0_TEMPLATE       = VBoxR0
- VBoxDD2R0_DEFS           = IN_RT_R0
- VBoxDD2R0_INCS           = build
- VBoxDD2R0_SOURCES        = \
- 	build/VBoxDD2R0.cpp
- if1of ($(VBOX_LDR_FMT), pe lx)
-  VBoxDD2R0_LIBS          = \
-  	$(PATH_STAGE_LIB)/VMMR0Imp$(VBOX_SUFF_LIB) \
-  	$(PATH_STAGE_LIB)/SUPR0$(VBOX_SUFF_LIB)
- endif
- $(call VBOX_SET_VER_INFO_R0,VBoxDD2R0,VirtualBox VMM Devices and Drivers 2$(COMMA) ring-0) # (last!)
-
-
  #
  # Ring-0 Services (library, linked into VMMR0.r0)
Index: trunk/src/VBox/Devices/build/VBoxDD2R0.cpp
===================================================================
--- trunk/src/VBox/Devices/build/VBoxDD2R0.cpp	(revision 74769)
+++ 	(revision )
@@ -1,32 +1,0 @@
-/* $Id$ */
-/** @file
- * VBoxDD2R0 - Built-in drivers & devices (part 2), ring-0 module.
- */
-
-/*
- * Copyright (C) 2011-2017 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-
-/*********************************************************************************************************************************
-*   Header Files                                                                                                                 *
-*********************************************************************************************************************************/
-#include <iprt/types.h>
-
-
-/*********************************************************************************************************************************
-*   Global Variables                                                                                                             *
-*********************************************************************************************************************************/
-#if defined(RT_OS_SOLARIS) && defined(IN_RING0)
-/* Dependency information for the native solaris loader. */
-extern "C" { char _depends_on[] = "vboxdrv VMMR0.r0"; }
-#endif
-
Index: trunk/src/VBox/Installer/darwin/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 74769)
+++ trunk/src/VBox/Installer/darwin/Makefile.kmk	(revision 74770)
@@ -479,12 +479,10 @@
 VBOX_DI_VBAPP_OTHER_UNIVERSAL_BINS = \
 	MacOS/VMMR0.r0 \
-	MacOS/VBoxDDR0.r0 \
-	MacOS/VBoxDD2R0.r0
+	MacOS/VBoxDDR0.r0
 
 ifdef VBOX_WITH_RAW_MODE
  VBOX_DI_VBAPP_OTHER_BINS = \
 	MacOS/VMMRC.rc \
-	MacOS/VBoxDDRC.rc \
-	MacOS/VBoxDD2RC.rc
+	MacOS/VBoxDDRC.rc
 else
  VBOX_DI_VBAPP_OTHER_BINS =
Index: trunk/src/VBox/Installer/freebsd/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 74769)
+++ trunk/src/VBox/Installer/freebsd/Makefile.kmk	(revision 74770)
@@ -115,6 +115,4 @@
 # Do not remove relocation information of these binaries
 VBOX_FBSD_STRIP_OBJ = \
-	VBoxDD2RC.rc \
-	VBoxDD2R0.r0 \
 	VBoxDDRC.rc \
 	VBoxDDR0.r0 \
Index: trunk/src/VBox/Installer/freebsd/pkg_plist
===================================================================
--- trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 74769)
+++ trunk/src/VBox/Installer/freebsd/pkg_plist	(revision 74770)
@@ -56,7 +56,5 @@
 @mode 644
 lib/virtualbox/VBoxDDRC.rc
-lib/virtualbox/VBoxDD2RC.rc
 lib/virtualbox/VBoxDDR0.r0
-lib/virtualbox/VBoxDD2R0.r0
 lib/virtualbox/VMMRC.rc
 lib/virtualbox/VMMR0.r0
Index: trunk/src/VBox/Installer/linux/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 74769)
+++ trunk/src/VBox/Installer/linux/Makefile.kmk	(revision 74770)
@@ -184,15 +184,12 @@
 # Do not remove relocation information of these binaries
 VBOX_LNX_STRIP_OBJ = \
-	VBoxDD2R0.r0 \
 	VBoxDDR0.r0 \
 	VMMR0.r0
 ifdef VBOX_NO_LINUX_RUN_INSTALLER
  VBOX_LNX_STRIP_OBJ += \
-	VBoxDD2R0.debug \
 	VBoxDDR0.debug \
 	VMMR0.debug
 else
  VBOX_LNX_DBG_BIN = \
-	VBoxDD2R0.debug \
 	VBoxDDR0.debug \
 	VMMR0.debug
@@ -201,15 +198,12 @@
 ifdef VBOX_WITH_RAW_MODE
  VBOX_LNX_STRIP_OBJ += \
-	VBoxDD2RC.rc \
 	VBoxDDRC.rc \
 	VMMRC.rc
  ifdef VBOX_NO_LINUX_RUN_INSTALLER
   VBOX_LNX_STRIP_OBJ += \
-	VBoxDD2RC.debug \
 	VBoxDDRC.debug \
 	VMMRC.debug
  else
   VBOX_LNX_DBG_BIN += \
-	VBoxDD2RC.debug \
 	VBoxDDRC.debug \
 	VMMRC.debug
Index: trunk/src/VBox/Installer/linux/debian/lintian-override.in
===================================================================
--- trunk/src/VBox/Installer/linux/debian/lintian-override.in	(revision 74769)
+++ trunk/src/VBox/Installer/linux/debian/lintian-override.in	(revision 74770)
@@ -50,7 +50,5 @@
 %VERPKG%: binary-without-manpage usr/bin/virtualbox
 %VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VBoxDDRC.rc
-%VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VBoxDD2RC.rc
 %VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VBoxDDR0.r0
-%VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VBoxDD2R0.r0
 %VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VMMRC.rc
 %VERPKG%: unstripped-binary-or-object usr/lib/virtualbox/VMMR0.r0
Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 74769)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 74770)
@@ -386,6 +386,4 @@
 SOLARIS_STRIP_OBJS.DST     := $(VBOX_PATH_SI_SCRATCH_PKG)/opt/VirtualBox/$(VBOX_SI_ARCH)
 SOLARIS_STRIP_OBJS = \
-	VBoxDD2RC.rc \
-	VBoxDD2R0.r0 \
 	VBoxDDRC.rc \
 	VBoxDDR0.r0 \
Index: trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd
===================================================================
--- trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd	(revision 74769)
+++ trunk/src/VBox/Installer/win/Scripts/PackDriversForSubmission.cmd	(revision 74770)
@@ -233,8 +233,4 @@
 echo %_MY_OPT_BINDIR%\VBoxDDR0.r0 VBoxDDR0.r0>>                                         "%_MY_OPT_DDF_FILE%"
 if "%_MY_OPT_WITH_PDB%" == "1" echo %_MY_OPT_PDBDIR%\VBoxDDR0.pdb VBoxDDR0.pdb>>        "%_MY_OPT_DDF_FILE%"
-if not exist %_MY_OPT_BINDIR%\VBoxDD2R0.r0 goto no_vboxdd2r0
-echo %_MY_OPT_BINDIR%\VBoxDD2R0.r0 VBoxDD2R0.r0>>                                       "%_MY_OPT_DDF_FILE%"
-if "%_MY_OPT_WITH_PDB%" == "1" echo %_MY_OPT_PDBDIR%\VBoxDD2R0.pdb VBoxDD2R0.pdb>>      "%_MY_OPT_DDF_FILE%"
-:no_vboxdd2r0
 
 if "%_MY_OPT_WITH_EXTPACK" == "0"   goto no_extpack_ddf
Index: trunk/src/VBox/Installer/win/Scripts/VMMR0.inf
===================================================================
--- trunk/src/VBox/Installer/win/Scripts/VMMR0.inf	(revision 74769)
+++ trunk/src/VBox/Installer/win/Scripts/VMMR0.inf	(revision 74770)
@@ -30,5 +30,4 @@
 VMMR0.r0=1
 VBoxDDR0.r0=1
-VBoxDD2R0.r0=1
 
 [DestinationDirs]
@@ -48,5 +47,4 @@
 VMMR0.r0,,,2
 VBoxDDR0.r0,,,2
-VBoxDD2R0.r0,,,2
 
 [Strings]
Index: trunk/src/VBox/Installer/win/VBoxMergeApp.wxi
===================================================================
--- trunk/src/VBox/Installer/win/VBoxMergeApp.wxi	(revision 74769)
+++ trunk/src/VBox/Installer/win/VBoxMergeApp.wxi	(revision 74770)
@@ -307,6 +307,4 @@
         <File Id="file_VBoxDDRC.rc" Name="VBoxDDRC.rc"
               Source="$(env.PATH_OUT)\bin\VBoxDDRC.rc" />
-        <File Id="file_VBoxDD2RC.rc" Name="VBoxDD2RC.rc"
-              Source="$(env.PATH_OUT)\bin\VBoxDD2RC.rc" />
 
         <File Id="file_VMMR0.r0" Name="VMMR0.r0"
@@ -314,6 +312,4 @@
         <File Id="file_VBoxDDR0.r0" Name="VBoxDDR0.r0"
               Source="$(env.PATH_OUT)\bin\VBoxDDR0.r0" />
-        <File Id="file_VBoxDD2R0.r0" Name="VBoxDD2R0.r0"
-              Source="$(env.PATH_OUT)\bin\VBoxDD2R0.r0" />
 
 <?if $(env.VBOX_WITH_CROGL) = "yes" ?>